<?php	
	class wialon_ips {				
		private $log = "";						
		private $ip = "";		
		private $port = "";		
		private $socket = "";						
		
		private $debug_mode = "1";	
		
		public function __construct($client,$ip,$port) {							
			$this->log = new logs($client);			
			$this->ip = $ip;			
			$this->port = $port;						
			$this->socket = socket_create(AF_INET, SOCK_STREAM, 0);			
			$this->connect();		
			socket_set_nonblock($this->socket);
			socket_set_option($this->socket,SOL_SOCKET, SO_RCVTIMEO, array("sec" => 5, "usec" => 0));
		}								
		
		public function connect() {			
			if ($this->debug_mode == "1")
				$this->log->trace("Attemp connection Wialon IPS to " . $this->ip . ":" . $this->port);					
			// 
			if (!($res=@socket_connect($this->socket, $this->ip, $this->port))) {
				$this->log->trace("Error connection Wialon IPS to " . $this->ip . ":" . $this->port);				
				return;			
			}
			if ($this->debug_mode == "1")
				$this->log->trace("Good connection Wialon IPS to " . $this->ip . ":" . $this->port);					
		}				
		
		public function send_packet($data) {			
			
			if (!$this->socket) { return; }			
			
			if ($this->debug_mode == "1")
				$this->log->trace("Attemp send packet " . $data);			
				
			if (!socket_write($this->socket, $data . "\r\n", strlen($data . "\r\n"))) {
				$this->log->trace("Error send packet " . $data);
				$this->disconnect();
				$this->connect();
				return "";
			}
			
			if ($this->debug_mode == "1")
				$this->log->trace("Correct send packet " . $data);
			
			$curr_time = time();
			while (1) {
				$res = socket_read($this->socket, 1000);
				if (time() - $curr_time > 5 || $res) 
					break;
			}
			
			$pos = strpos($res, "\r\n");
			if ($pos > 0) 
				$res = substr($res, 0, $pos);
			
			if ($res == "") {
			    $this->log->trace("Error get answer (" . (time() - $curr_time) . ") packet '" . $data. "'");	
			} else {
				if ($this->debug_mode == "1")
					$this->log->trace("Answer (" . (time() - $curr_time) . ") packet '" . $res. "'");	
			}
			return $res;		
		}				
		
		public function disconnect() {			
			if (!$this->socket) { return;}
			$this->log->trace("Disconnect connection Wialon IPS to " . $this->ip . ":" . $this->port);								
			socket_close($this->socket);
			$this->socket = "";	
		}
		
		public function generate_string_params($string_params,$type) {
			
			$new_string = "";
			
			$params_arr = split("," , $string_params);
			for ($j=0; $j < count($params_arr); $j++) {
			      $param = $params_arr[$j];
			      $param_arr = split(":",$param);
			      if (sizeof($param_arr) != 2) { continue; }
			      $param_name = $param_arr[0];
			      $param_value = $param_arr[1];
			      
			      if ($new_string != "") 
				  $new_string = $new_string . ",";
				  
			      $new_string = $new_string . $param_name . ":" . $type . ":" . $param_value;
			}
			
			return $new_string;		
		}
		
		public function search_sats($string_params) {
			
			$params_arr = split("," , $string_params);
			for ($j=0; $j < count($params_arr); $j++) {
			      $param = $params_arr[$j];
			      $param_arr = split(":",$param);
			      if (sizeof($param_arr) != 2) { continue; }
			      $param_name = $param_arr[0];
			      $param_value = $param_arr[1];
			      
			      if ($param_name == "SATS") 
				  return $param_value;
			}
			
			return 0;		
		}
	} 
?>